package rocks.zipcode.io.quiz4.generics;

import java.util.*;

/**
 * @author leon on 11/12/2018.
 */
public class GenericUtils {
    public static <_ extends Comparable> Iterable<? extends Iterable<_>> powerSet(Set<_> originalSet) {
        Set<Set<_>> sets = new HashSet<Set<_>>();
        if (originalSet.isEmpty()){
            sets.add(new HashSet<_>());
            return sets;
        }
        List<_> list = new ArrayList<_>(originalSet);
        _ head = list.get(0);
        Set<_> rest = new HashSet<_>(list.subList(1, list.size()));
        for (Iterable<_> set : powerSet(rest)){
            Set<_> newSet = new HashSet<_>();
            newSet.add(head);
            newSet.addAll((Collection<? extends _>) set);
            sets.add(newSet);
            sets.add((Set<_>) set);
        }

        return sets;
    }

    public static <_ extends Comparable> Iterable<? extends Iterable<_>> powerSet(_... originalSet) {
        return powerSet(new TreeSet<>(Arrays.asList(originalSet)));
    }
}

