package rocks.zipcode.io.quiz4.fundamentals;

import java.util.ArrayList;
import java.util.LinkedHashSet;
import java.util.List;
import org.apache.commons.lang3.StringUtils;

/**
 * @author leon on 11/12/2018.
 */
public class StringEvaluator {
    public static String[] getAllPrefixes(String string) {
        List<String> pre = new ArrayList<>();
        for (int i = 0; i <= string.length(); i++){
            for (int j = i; j < string.length(); j++){
                pre.add(string.substring(i, j+1));
            }
        }
        pre = new ArrayList<String>(new LinkedHashSet<String>(pre));
        return pre.toArray(new String[0]);
    }

    public static String[] getCommonPrefixes(String string1, String string2) {
        String prefix = "";
        int min = Math.min(string1.length(), string2.length());
        for (int i = 0; i < min; i++){
            if (string1.charAt(i) == string2.charAt(i)){
                prefix = string1.substring(0, i);
            }
        }
        return new String[]{prefix};
    }

    public static String getLargestCommonPrefix(String string1, String string2) {
        int start = 0;
        int max = 0;
        for (int i = 0; i < string1.length(); i++){
            for (int j = 0; j < string2.length(); j++){
                int x = 0;
                while (string1.charAt(i + x) == string2.charAt(j + x)){
                    x++;
                    if (((i + x) >= string1.length()) || ((j + x) >= string2.length()))
                        break;
                }
                if (x > max){
                    max = x;
                    start = i;
                }
            }
        }
        return string1.substring(start, (start + max));
    }
}
